/**
* @package: ArrayTools
* @author: Kostyantyn Didenko
* @date: 07.29.2017
*/

const FlattenArray = require('./flatten_array.js').FlattenArray;

function PatchedArray(array) {
	'use strict'
	// store the given original array as a hidden property
	//TODO: think if storing of original Array is required (may double the Object size)
	const inputArray = array ? array : [];	
}

// inherit from the Flatten Array type
PatchedArray.prototype = FlattenArray.prototype;
PatchedArray.prototype.constructor = PatchedArray;

/**
* Extended sorting method implementation
* @param {String} property name of inner Objects to use for ordering
* @returns {Array} sorted Array
*/
PatchedArray.prototype.setSortOrderPropertyPattern = function(property) {
		
}

/**
* Method for building HTML diff table between the current Array and given parameter
* @param {Array} array to diff to
* @returns {String} HTML table diff between these two Arrays 
*/
PatchedArray.prototype.htmlDiff = function(array) {
	
}


module.exports.PatchedArray = PatchedArray;